#!/bin/bash

### FAIRLY MINIMAL EXAMPLE

pwd=`pwd`

if true
then
	### this is for Cygwin /cygdrive/c/...
	url="file:///${pwd:10:1}:/${pwd:12}/repos"
else
	### this is for real Linux (if I've got it right)
	url="file://${pwd}/repos"
fi

echo ${url}

### set to true/false as required
if true
then
	### GENERATE THE REPOSITORY

	### create repository
	svnadmin create repos

	### create working copy
	svn checkout ${url} wc

	cd wc

	### repos @ -r0

	### add some files
	mkdir dir1
	echo "This is file 1" > dir1/file1.txt
	echo "This is file 2" > dir1/file2.txt
	mkdir dir2
	echo "This is file A" > dir2/fileA.txt
	echo "This is file B" > dir2/fileB.txt

	svn add dir1 dir2
	svn commit -m "Additions - initial files"
	svn update

	### repos @ -r1

	### delete some files
	svn del dir1/file1.txt dir2/fileA.txt
	svn commit -m "Deletions"
	svn update

	### repos @ -r2

	### rename a dir
	svn rename dir1 dir1_renamed
	svn commit -m "Renames"
	svn update

	### repos @ -r3

	cd ..
fi

### some stuff that works...

function echo_run ()
{
	echo "-------- $1 --------"
	$1
	echo "--------"
}

echo
echo "======== OKAY - should succeed ========"
echo

echo_run "svn list ${url} -R"
echo_run "svn list ${url} -r1 -R"
echo_run "svn list ${url} -r2"
echo_run "svn list ${url}/dir2 -r2"
echo_run "svn cat ${url}/dir2/fileA.txt -r1"
echo_run "svn cat ${url}/dir2/fileB.txt -r1"
echo_run "svn cat ${url}/dir2/fileB.txt -r2"

echo
echo "======== OKAY - should fail ========"
echo

echo_run "svn cat ${url}/dir2/fileA.txt -r2"
# but error message refers to "revision 3"

### some stuff that seems wrong...

echo
echo "======== NOT OKAY - should succeed ========"
echo

### dir1/file1.txt existed in both -r1 and -r2
echo_run "svn list -r1 ${url}/dir1"
echo_run "svn cat -r1 ${url}/dir1/file1.txt"
echo_run "svn cat -r2 ${url}/dir1/file1.txt"
# and error messages refer to "revision 3"

echo
echo "======== NOT OKAY? - should fail? ========"
echo

echo_run "svn list -r1 ${url}/dir1_renamed"

### NB: an equivalent to this works fine in the TortoiseSVN repository browser
